package grunddaten;

import java.util.Random;

// Beinhaltet den Status eines Agenten und implementiert die Statusaenderungs-
// funktion (Bewegen des Agenten)

// in: Agentstatus, Seed (fuer) Zufallsgenerator
// Methoden: 	aendern() 		... aendert den Status des Agenten (bewegt Ihn)
//				ausgabe_status  ... gibt den Status des Agenten zurueck
public class AgentStatus {
    
    
    private Status agent_status;
    private long seed;
    private Random r;
    
        
     /* konstruktor */
    public AgentStatus(Status agent_status, long seed) {
        this.agent_status = agent_status;
        this.seed = seed;
        
        // Zufallsgenerator mit Seed generieren
    	r = new Random(seed);
        
    }
    
    
    // Ermitteln einer neuen Position des Agenten (Bewgen des Agenten)
    // in:  alter Agentstatus
    // out: neuer Agentstatus
    // Abhaengig von der Positon und Ausrichtung des Agenten gibt es 
    // 4 gueltige neue Zustaende:
    //   z.B. Agent ist auf Position 2,2 mit der Ausrichtung N
    //   Der neue Status kann nun sein:
    //      1.) 2,1 N
    //		2.) 2,2 O
    //		3.) 2,2 S
    //		4.) 2,2 W
    public Status get_new(Status ein_st) {
    	char richtungen[] = {'N','O','S', 'W'};
    	int zufall;
    	Point3d temp;
    	Status temp_st = (Status) ein_st.clone();
    	    	    	
    	zufall = r.nextInt(9); // Zufallszahl zwischen 0..8
    	// von den ersten 4 Faellen sind immer 3 Richtungswechsel und
    	// 1 Positionswechsel
    	// somit kann man das Verhaeltnis zw. Richtungs und Postionswechseln angeben
    	// z.B. 9: 3 Richtunswechsel und 6 Positionswechsel
    	
    	// 1. Fall Agent aendert seine Position (abhaengig von der Ausrichtung)
    	if (zufall > 3 || temp_st.ausgabe_ausrichtung() == richtungen[zufall]) 			{
    		// Status des Agenten
    		temp = (Point3d) temp_st.ausgabe_position().clone();
    		
    		// Position aendern (einzelne Koordinate)
    		switch (temp_st.ausgabe_ausrichtung()) {
    			case 'N': temp.aendere_y(temp.ausgabe_y()-1); break;
    			case 'O': temp.aendere_x(temp.ausgabe_x()+1); break;
    			case 'S': temp.aendere_y(temp.ausgabe_y()+1); break;
    			case 'W': temp.aendere_x(temp.ausgabe_x()-1); break;
    			}
    		
    		// Status des Agenten aendern
    		temp_st.aendere_position(temp);	
    		}
    	
    	// 2. Fall Agent aendert seine Ausrichtung
    	else
    		temp_st.aendere_ausrichtung(richtungen[zufall]);
    	
    	return temp_st;	 	 	
    }

	
	// aendern des Agent Status
	public void aendern(Status agent_status) {
		this.agent_status = agent_status;
	}
	
		
	// Ausgabe des Agentstatus
	public Status ausgabe_status() {
		return agent_status;
	}


}
